/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package groovy.rainmaker.rest;

def sortByRelevance(resources, field, value)
{
    value = value.toUpperCase();
    
    return resources.sort { resource -> 
        def tokens = resource[field]?.toString().toUpperCase().tokenize();
        
        if (!tokens || tokens.isEmpty())
            return 5;
        
        if (tokens[0].startsWith(value))
            return tokens[0].equals(value) ? 0 : 1;
        
        if (tokens.find { it.startsWith(value) })
            return 2;
        
        if (tokens.find { it.contains(value) })
            return 3;
        
        return 4;
    };
}
